Groups added to watchers are not shown as links
Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 5.0.4

Resolution: Fixed Affected version: 5.0.3
Description

After #4511 (v4.2.0), its possible to add Redmine groups as watchers on issues.

Users are shown as links, and groups are shown in Overview as links, and in Assignee field. However, gruops are shown as text

when they are added to watchers

In the screenshot bellow, you can see 2 groups - 1 in assigne and 1 in watchers. You can see that user watcher is provided as link,

while group is text
This behavior is not consistent and its harder for people involved to see group members (they must go to Overview page and search

for that group there).

Associated revisions

Revision 21967 - 2022-11-28 23:59 - Marius BALTEANU

Fix groups added to watchers are not shown as links (#37958).

Patch by Mizuki ISHIKAWA.

Revision 21970 - 2022-11-29 08:17 - Marius BALTEANU
Merge r21967 from trunk to 5.0-stable (#37958).

History

#1 - 2022-11-24 03:42 - Mizuki ISHIKAWA

I think the following code will solve the problem.

diff --git a/app/helpers/watchers_helper.rb b/app/helpers/watchers_helper.rb

index fc97dal056..97067378e4 100644
-—- a/app/helpers/watchers_helper.rb
+++ b/app/helpers/watchers_helper.rb
@@ -51,7 +51,7 @@ module WatchersHelper
lis = object.watcher_users.collect do |user|
s = ''.html_safe
s << avatar (user, :size => "16").to_s
= s << link_to_user (user, :class => 'user')

+ s << link_to_principal (user, class: user.class.to_s.downcase)

if object.respond_to?(:visible?) && user.is_a? (User)

&& !object.visible? (user)

s << content_tag('span', 1l(:notice_invalid_watcher), class: 'icon-only icon-warning', title: 1l (:notic

e_invalid_watcher))
end

diff --git a/test/functional/issues_controller_test.rb b/test/functional/issues_controller_test.rb

index alOabbdl29..58e51348a9 100644
——— a/test/functional/issues_controller_test.rb

2025-05-17

1/2



https://www.redmine.org/issues/4511

+++ b/test/functional/issues_controller_test.rb
@@ -2726,7 +2726,7 @Q@ class IssuesControllerTest < Redmine::ControllerTest
end
assert_select "li.user-10" do
assert_select 'img.gravatar([title=?]', 'A Team'

- assert_select 'alhref="/users/10"]', false
+ assert_select 'alhref="/groups/10"]"'
assert_select 'a[class*=delete]'
end

end
#2 - 2022-11-24 11:58 - Dmitry Makurin
The problem is that there are multiple methods to render user/group links:
e link_to_user
e link_to_principal

e link_to_group

Before r21073 only link_to_(user/group) existed and it was clear what method was responsible for.

link_to_principal combined both link_to_user and link_to_group and now it's really confusing what the difference between all of them.
| would suggest to unify link_to_user and link_to_group into link_to_principal or properly decompose link_to_principal.

#3 - 2022-11-29 00:00 - Marius BALTEANU

- Status changed from New to Resolved

- Assignee set to Marius BALTEANU

- Target version set to 5.0.4

- Resolution set to Fixed
I've committed for now the patch posted by Mizuki to catch the release of new maintenance version.
#4 - 2022-11-29 00:01 - Marius BALTEANU
Dmitry Makurin wrote:
The problem is that there are multiple methods to render user/group links:

e link_to_user

e link_to_principal

e link_to_group

Before r21073 only link_to_(user/group) existed and it was clear what method was responsible for.

link_to_principal combined both link_to_user and link_to_group and now it's really confusing what the difference between all of them.
| would suggest to unify link_to_user and link_to_group into link_to_principal or properly decompose link_to_principal.
Indeed, it sounds confusing. If you have code proposal, I'll very happy to review it.

#5 - 2022-12-01 16:03 - Marius BALTEANU

- Status changed from Resolved to Closed
